
;
;
;
;
;
;
;
;  32
;  16   .
;
;
;
;
;**************************************************************************************************************
;  
;**************************************************************************************************************

.include 	"m32def.inc"		;  ATMega32


;==============================================================================================================
;   // RAM
;==============================================================================================================
;
;******************************************************************************
;  
;******************************************************************************

.def	Temp =R16
.def	Temp1=R17
.def	Temp2=R18
.def	Temp3=R19
.def	Temp4=R20			;   /  SREG
.def	Temp5=R21 			;   / 
.def	Temp6=R22			; 		
.def	Temp7=R23			; 		
.def	Temp8=R24			;
; .def	wiretemp =R25			;    1-Wire (      )
; .def 	wireres	 = R2			;    r0...r15  (      )			




;******************************************************************************
; 
;******************************************************************************


.dseg					;  


StrPtr: .byte 2				;  "StrPtr"  (      )



;******************************************************************************
; 
;******************************************************************************


.equ	XTAL = 16000000				;  16 
.equ	baudrate = 9600				;  UART
.equ	bauddivider = XTAL/(16*baudrate)-1	;     UART


;==============================================================================================================
;   // FLASH // 
;==============================================================================================================

.cseg	


;******************************************************************************
;  
;******************************************************************************	
	

.org 0					; External Pin, Power-on Reset, Brown-out Reset, and Watchdog Reset
rjmp reset				;  				



					; .ORG $016
.ORG URXCaddr				; URXCaddr = 0x001a / USART, Rx Complete
RJMP RX_OK	  			; (USART,RXC) USART, Rx Complete (    )



					; ORG $018
.ORG UDREaddr				; UDREaddr = 0x001c / USART Data Register Empty
RJMP UD_OK       			; (USART,UDRE) USART Data Register Empty (     )



					; .ORG $01A
.ORG UTXCaddr				; UTXCaddr = 0x001e / USART, Tx Complete
RJMP TX_OK      			; (USART,TXC) USART, Tx Complete (     )



.org INT_VECTORS_SIZE			;   


;******************************************************************************
; 
;******************************************************************************

reset:					;  



	cli				;    



	ldi Temp, low(RAMEND)		;  
	out SPL, Temp			;
	ldi Temp, high(RAMEND)		;
	out SPH, Temp			;




;******************************************************************************
;  
;******************************************************************************


;         
;     ,        
;        




;	ldi Temp,0b00100000		;   "D" (0-, 1-)
;	out DDRD,Temp			; 0000000 - "" 
					 
		
			

;	ldi Temp,0b00100000		;  _1   "D" (   )
;	out PortD,Temp			; 



				
;******************************************************************************
;   
;******************************************************************************





				
;******************************************************************************
;   UART
;******************************************************************************


;   (  UBBRx )

uart_init:	

	LDI R16, low(bauddivider)	;
	OUT UBRRL, R16			; UBRRL
	LDI R16, high(bauddivider)	;
	OUT UBRRH, R16			; UBRRH





;   UCSRA    - ( UCSRA )

	LDI R16,0
	OUT UCSRA, R16





;  , - .

	LDI R16, (1<<RXEN)|(1<<TXEN)|(1<<RXCIE)|(1<<TXCIE)|(0<<UDRIE)			;    ,       . 
	OUT UCSRB, R16									;           . 
											;          UDRIE    ! 



;   - 8 ,    UCSRC,      URSEL

	LDI R16, (1<<URSEL)|(1<<UCSZ0)|(1<<UCSZ1)
	OUT UCSRC, R16






;******************************************************************************
;   (     )
;******************************************************************************


	LDI R17, low(String*2)		;      "String"
	LDI R18, High(String*2)		;      "String"
 
	STS StrPtr, R17			;      "String"   "StrPtr"
	STS StrPtr+1, R18		;      "String"   "StrPtr"




;******************************************************************************
;  
;******************************************************************************			

	RCALL	LCD_INIT		;   (  "LCD_INIT"     )


;******************************************************************************
;   
;******************************************************************************

	sei				;   
	

;*******************************************************************************
;   *****************************************************************
;*******************************************************************************

;   


read_key_ok:

	sbis PIND, 2			; D2=1 (   ),  . 

	rjmp read_key_ok		;     ""   






;*******************************************************************************

;  UART

;    ,       . 
;       UDRIE    ! 



	LDI 	R16, (1<<RXEN)|(1<<TXEN)|(1<<RXCIE)|(1<<TXCIE)|(1<<UDRIE)
	OUT 	UCSRB, R16

;*******************************************************************************


main:


	rjmp main			; 






;*******************************************************************************
;      UART
;*******************************************************************************


RX_OK:		



	in temp4, SREG		;    "SREG"/////////////////////////////////////////////////////
	push temp4

	push R16		;    R16




 
	IN R16, UDR		;      UDR  
				;    
				; ,   ,   




				;   R16
	rcall printhex		;    
 


Rx_Exit:

	pop R16			;    R16 


	pop temp4		;    "SREG" ////////////////////////////////////////////////////
	out SREG, temp4




	RETI



;*******************************************************************************
;     
;*******************************************************************************



UD_OK:




	in temp4, SREG		;    "SREG"/////////////////////////////////////////////////////
	push temp4

	push R16		;    R16


	PUSH ZL			;    Z
	PUSH ZH
 

	LDS ZL, StrPtr		;       (       )
	LDS ZH, StrPtr+1
 

	LPM R16, Z+		; lpm -    R16   -    "Z"
				;   "Z"    
 

	CPI R16, 0		;    ,   
	BREQ STOP_RX		;   
 

	OUT UDR, R16		;    .
 

	STS StrPtr, ZL		;     
	STS StrPtr+1, ZH	; ,   (   ) 			
 



Exit_RX:

	POP ZH			;    , .
	POP ZL

	pop R16			;    R16 


	pop temp4		;    "SREG" ////////////////////////////////////////////////////
	out SREG, temp4



	RETI
 


;    ,   

STOP_RX:

	LDI R16, (1<<RXEN)|(1<<TXEN)|(1<<RXCIE)|(1<<TXCIE)|(0<<UDRIE)
	OUT UCSRB, R16


	RJMP Exit_RX


;*******************************************************************************
;        UART
;*******************************************************************************

TX_OK:

			;       ,    

	RETI


;*******************************************************************************
;     (   )
;*******************************************************************************

String:		


.db	"Hello Interrupt Request", 0




;*******************************************************************************
;     16-   ( 2  )
;*******************************************************************************

;  16  
;    X (XH:XL)


printhex16: 


        mov r16 , XH
        rcall printhex
        mov r16 , XL
        rcall printhex
        ret 


;*******************************************************************************
;        Hex-
;*******************************************************************************

;     hex ,         
;  r16     


printhex: 
   
	push r16			 ;      (    )
	swap r16			 ;   ,      
	rcall printhex1			 ;       
	pop   r16			 ;    

printhex1:
    
	andi r16, 0x0f			 ;    ( )
	rcall lcd_char			 ;      
	ret   





;*******************************************************************************
;   HEX  BCD
;*******************************************************************************

;     R16



HEX_to_BCD:

	clr r17				;   help

HEX_to_BCD_l:

	subi r16,10			; temp = temp  10
	brcs HEX_to_BCD_2		; ,   
	inc r17				;  r17    
	rjmp HEX_to_BCD_l		;     

HEX_to_BCD_2:

	subi r16,-10			;     r16
	swap r17			;   
	or r16,r17			;      BCD

	ret



;*******************************************************************************
;  
;*******************************************************************************

.include "lcd5110rus.asm"		;   	





;*******************************************************************************
;*******************************************************************************
;*******************************************************************************
;*******************************************************************************
;*******************************************************************************
;*******************************************************************************
;*******************************************************************************
;*******************************************************************************







